clear;




%%
load data/Bonome_raw.mat
%
datasets.bono = struct;
datasets.bono.origin = struct;
%
datasets.bono.origin.GeneName = GeneName;
[~,ixTimes]                   = sort(Times);
datasets.bono.origin.Data     = Data(ixTimes,:)';
datasets.bono.origin.Times    = Times(ixTimes);
datasets.bono.origin.d        = d(ixTimes);
%

%
disp('Added original Bonome dataset');
clear d Data GeneName SampleName Times ixTimes

%% 
load data/tcga_raw.mat
%
datasets.tcga = struct;
datasets.tcga.origin = struct;
%
datasets.tcga.origin.GeneName = GeneName;
[~,ixTimes]                   = sort(Times);
datasets.tcga.origin.Data     = Data(ixTimes,:)';
datasets.tcga.origin.Times    = Times(ixTimes);
datasets.tcga.origin.d        = d(ixTimes);
disp('Added original TCGA dataset');
clear d Data GeneName Times

%% 
load data/tothill_raw.mat
%
datasets.tothill = struct;
datasets.tothill.origin = struct;
%
datasets.tothill.origin.GeneName = GeneNames;
[~,ixTimes]                      = sort(Times);
datasets.tothill.origin.Data     = Data(:,ixTimes);
datasets.tothill.origin.Times    = Times(ixTimes);
datasets.tothill.origin.d        = d(ixTimes);
disp('Added original Tothill dataset');
clear d Data GeneNames Times

%%
% Find common genes
datasets.tcga.common    = struct;
datasets.bono.common    = struct;
datasets.tothill.common = struct;

% set function linkage for common genes
load data/FunctionLinkage.mat

int_tcga_bono      = intersect( datasets.tcga.origin.GeneName, datasets.bono.origin.GeneName);
int_tcga_bono_funl = intersect(int_tcga_bono,GeneName);
target_genes       = partial_intersect(int_tcga_bono_funl, datasets.tothill.origin.GeneName, '///');
% necessary to get index of functional linkage
[~,~,IX2] = intersect(target_genes,GeneName);

%%
%
[~, IX1, ~] = intersect( datasets.bono.origin.GeneName, target_genes );
datasets.bono.common.Data     = datasets.bono.origin.Data( IX1, :);
datasets.bono.common.GeneName = datasets.bono.origin.GeneName( IX1 );
datasets.bono.common.d        = datasets.bono.origin.d;
datasets.bono.common.Times    = datasets.bono.origin.Times;
fprintf('Added Bonome common genes dataset (%d)\n', length(datasets.bono.common.GeneName));
%%
[~, IX1, ~] = intersect( datasets.tcga.origin.GeneName, target_genes );
datasets.tcga.common.Data     = datasets.tcga.origin.Data( IX1, :);
datasets.tcga.common.GeneName = datasets.tcga.origin.GeneName( IX1 );
datasets.tcga.common.d        = datasets.tcga.origin.d;
datasets.tcga.common.Times    = datasets.tcga.origin.Times;
fprintf('Added TCGA common genes dataset (%d)\n', length(datasets.tcga.common.GeneName));
%%
[~, ~, IX1] = partial_intersect( target_genes, datasets.tothill.origin.GeneName, '///' );
datasets.tothill.common.Data     = datasets.tothill.origin.Data( IX1, :);
datasets.tothill.common.GeneName = datasets.tothill.origin.GeneName( IX1 );
datasets.tothill.common.d        = datasets.tothill.origin.d;
datasets.tothill.common.Times    = datasets.tothill.origin.Times;
fprintf('Added Tothill common genes dataset (%d)\n', length(datasets.tothill.common.GeneName));
clear IX1
%%

[~, IX1, ~] = intersect( datasets.bono.origin.GeneName, target_genes);
datasets.bono.common_funlinkage.Data     = datasets.bono.origin.Data( IX1, :);
datasets.bono.common_funlinkage.GeneName = datasets.bono.origin.GeneName( IX1 );
datasets.bono.common_funlinkage.d        = datasets.bono.origin.d;
datasets.bono.common_funlinkage.Times    = datasets.bono.origin.Times;
datasets.bono.common_funlinkage.S        = Normal_M(FunctionalLinkage(IX2,IX2));
fprintf('Added Bono Function Linkage common genes dataset (%d)\n', length(datasets.bono.common_funlinkage.GeneName));
%%
[~, IX1, ~] = intersect( datasets.tcga.origin.GeneName, target_genes);
datasets.tcga.common_funlinkage.Data     = datasets.tcga.origin.Data( IX1, :);
datasets.tcga.common_funlinkage.GeneName = datasets.tcga.origin.GeneName( IX1 );
datasets.tcga.common_funlinkage.d        = datasets.tcga.origin.d;
datasets.tcga.common_funlinkage.Times    = datasets.tcga.origin.Times;
datasets.tcga.common_funlinkage.S        = Normal_M(FunctionalLinkage(IX2,IX2));
fprintf('Added TCGA Function Linkage common genes dataset (%d)\n', length(datasets.tcga.common_funlinkage.GeneName));
%%
[~, ~, IX1] = partial_intersect( target_genes, datasets.tothill.origin.GeneName, '///' );
datasets.tothill.common_funlinkage.Data     = datasets.tothill.origin.Data( IX1, :);
datasets.tothill.common_funlinkage.GeneName = datasets.tothill.origin.GeneName( IX1 );
datasets.tothill.common_funlinkage.d        = datasets.tothill.origin.d;
datasets.tothill.common_funlinkage.Times    = datasets.tothill.origin.Times;
datasets.tothill.common_funlinkage.S        = Normal_M(FunctionalLinkage(IX2,IX2));
fprintf('Added Tothill Function Linkage common genes dataset (%d)\n', length(datasets.tothill.common_funlinkage.GeneName));

clear FunctionalLinkage IX1 IX2 GeneName
%%
datasets.bono.common.Data_N            = Normal_M(datasets.bono.common.Data);
datasets.bono.common_funlinkage.Data_N = Normal_M(datasets.bono.common_funlinkage.Data);
disp('Normalized Bonome Data');
%%
datasets.tcga.common.Data_N            = Normal_M(datasets.tcga.common.Data);
datasets.tcga.common_funlinkage.Data_N = Normal_M(datasets.tcga.common_funlinkage.Data);
disp('Normalized TCGA Data');
%%
datasets.tothill.common.Data_N            = Normal_M(datasets.tothill.common.Data);
datasets.tothill.common_funlinkage.Data_N = Normal_M(datasets.tothill.common_funlinkage.Data);
disp('Normalized Tothill Data');
%%
datasets.bono.common.S = getS(datasets.bono.common.Data_N);
disp('Set Bonome common genes network');
%%
datasets.tcga.common.S = getS(datasets.tcga.common.Data_N);
disp('Set TCGA common genes network');
%%
datasets.tothill.common.S = getS(datasets.tothill.common.Data_N);
disp('Set Tothill common genes network');
%%
% removes original data
datasets.bono    = rmfield( datasets.bono,    'origin');
datasets.tcga    = rmfield( datasets.tcga,    'origin');
datasets.tothill = rmfield( datasets.tothill, 'origin');
%
sets = fieldnames(datasets);

for i = 1:length(sets)
    sets_name = sets{i};
    subsets = fieldnames( datasets.(sets_name) );
    for j = 1:length(subsets)
       subsets_name = subsets{j};
       mydata = datasets.(sets_name).(subsets_name);
       save(sprintf('data/generated_source/%s_%s.mat',subsets_name,sets_name), 'mydata' );
       clear mydata
    end
end











