%%
clc;
clear;

k = 5;

%%
r00_my_config;
results_name = params.folder;

%%
sets_names = params.set_names;
sets_names = {'bono','tcga','tothill'};
% sets_names = {'bono', 'tcga'};
%
%
collection_names = params.collection_names;
collection_names = { 'common', 'common_funlinkage'};
% collection_names = { 'common'};
type_list = {};
result = struct;
for i = 1:length(sets_names)
    for j = 1:length(collection_names)
        result.(sprintf('%s_%s',collection_names{j},sets_names{i})) = struct;
    end
end
%%

reg_list = params.reg_list;
reg_list = {'degree', 'netcox'};
%%

for oo = 1:length(sets_names)
    set_name = sets_names{oo};
    %
    for yy = 1:length(collection_names)
        %
        datacol = collection_names{yy};


        type = sprintf('%s_%s',datacol,set_name);
        type_list{end+1} = type;
        fprintf('loading ''%s'' data...\n',type);
        % load Data
        data_prefix = sprintf('%s',type);
        %
        load(sprintf('data/generated_source/%s.mat',data_prefix));
        % load Data normalized object
        result.(type).Data = mydata.Data_N;
        result.(type).d    = mydata.d;
        %
        %
        myrun_meta = [];
        for rr = 1:length(reg_list)
            % load data from NetCox and DegreeCox
            load(sprintf('data/results/%s/%s_%0.2dk_%s.mat', results_name, data_prefix, k, reg_list{rr}));
            if isempty(myrun_meta)
                myrun_meta = myrun;
            else
                myrun_fields = fields(myrun);
                myrun_fields = myrun_fields(~strncmp(fields(myrun), 'idx_', 3));
                for ff = 1:length(myrun_fields)
                    for oo = 1:length(myrun_meta)
                        myrun_meta(oo).(myrun_fields{ff}) = myrun(oo).(myrun_fields{ff});
		    end
                end
            end
        end
        myrun = myrun_meta;
        %
        % L1 and L2
        %
        % load data from L1 + L2 regularization (done in R)
        r_file_path = sprintf('data/results/r_results/r_results_%s_%0.2dk.mat',type,k);
        if exist(r_file_path, 'file') == 2
          load(r_file_path);
          % add r_results to myrun
          for i = 1:size(r_results,1)
              myrun(i).beta_gl   = reshape(r_results(i,:,:,:),size(r_results,2),size(r_results,3),size(r_results,4));
              myrun(i).lambda_gl = lambda_vec(i,:);
              myrun(i).alpha_gl  = alpha_vec(i,:);
          end
        end
        %
        %
        result.(type).myrun = myrun;
        clear results mydata
    end
end
%%

% calculate best alpha/lambda parameters
btas = {'beta_nc','beta_dc','beta_gl'};
%btas = {'beta_dc', 'beta_nc'};
suffix = cell(size(btas));
for ix = 1:length(btas)
    bta_len = length(btas{ix});
    suffix{ix} = btas{ix}(6:bta_len);
end
tic;
fprintf('calculating best alpha/lambda params...\n');
cv_result =  struct; % cell( length(btas), length(type_list) );
best_idx  = struct;  % zeros( length(btas), length(type_list), 3 );
%
for kk = 1:length(type_list)
    %
    type             = type_list{kk};
    best_idx.(type)  = struct;
    cv_result.(type) = struct;
    %
    for bb = 1:length(btas) % each of the different beta types
        bta_name = btas{bb};
        disp(sprintf('%s %s',type,bta_name));	
        if ~isfield(result.(type).myrun(1), bta_name)
           disp('skipping...');
           continue ;
        end
        [nlambda, nalpha, ~]        = size(result.(type).myrun(1).(bta_name));
        %
        % initialize structure to store results for each lambda / alpha
        cv_result.(type).(bta_name).tab    = zeros( nlambda, nalpha );
        cv_result.(type).(bta_name).lambda = zeros( nlambda, nalpha );
        cv_result.(type).(bta_name).alpha  = zeros( nlambda, nalpha );
        %
        lambda_temp = result.(type).myrun.(strcat('lambda_', suffix{bb}));
        if isfield(result.(type).myrun, strcat('alpha_',suffix{bb}))
            alpha_temp = result.(type).myrun.(strcat('alpha_',suffix{bb}));
        else
            alpha_temp = 1;
        end
        %
        for ll = 1:nlambda % each lambda
            for aa = 1:nalpha % each alpha
                %
                cv_result.(type).(bta_name).lambda(ll,aa) = lambda_temp(ll);
                cv_result.(type).(bta_name).alpha(ll,aa)  = alpha_temp(aa);
                %
                my_bta = reshape( result.(type).myrun(j).(bta_name)(ll,aa,:), [], 1);
	        %
		fprintf('  alpha = %.14f  || lambda = %.14f (%s)\n', lambda_temp(ll), alpha_temp(aa), bta_name);
		%
                for j = 1:length(result.(type).myrun) % each j is an different cv
                    %
		    idx_train = result.(type).myrun(j).idx_train;
                    log_pl_all = loglike( result.(type).Data',              my_bta, result.(type).d);
		    log_pl_tra = loglike( result.(type).Data(:,idx_train)', my_bta, result.(type).d(idx_train));
		    fprintf('    %d-fold: pl_all - pl_train => %f - %f = %f\n', j, log_pl_all, log_pl_tra , log_pl_all- log_pl_tra);
		    cv_result.(type).(bta_name).tab(ll, aa) = cv_result.(type).(bta_name).tab(ll, aa) ...
                        + abs(log_pl_all - log_pl_tra);
                end
		fprintf('    sum = %.14f | min bta = %f | max bta = %f\n', cv_result.(type).(bta_name).tab(ll,aa), min(my_bta), max(my_bta));
            end

        end
    end

    for bb = 1:length(btas)
        bta_name = btas{bb};
        %
        if ~isfield(result.(type).myrun(1), bta_name)
        	continue;
        end
        %
        best_idx.(type).(bta_name) = struct();
        % get table size
        [nlambda, nalpha, ~]                                             = size(result.(type).myrun(1).(bta_name));
        % set sorted vector with CV partial log-likelihood value
        [best_idx.(type).(bta_name).L, sorted_idx]                       = sort(cv_result.(type).(bta_name).tab(:));
        % set indexes for sorted rows and columns
        [best_idx.(type).(bta_name).row, best_idx.(type).(bta_name).col] = ind2sub( [nlambda, nalpha], sorted_idx);
        % 
        temp_name = ['alpha_', bta_name(end-1:end)];
        best_idx.(type).(bta_name).alpha = result.(type).myrun(j).(temp_name)(best_idx.(type).(bta_name).col)';
        lambda_name = ['lambda_',bta_name( (strfind(bta_name,'_')+1):end)];
        best_idx.(type).(bta_name).lambda = result.(type).myrun(j).(lambda_name)(best_idx.(type).(bta_name).row)';
    end

end
toc;
%%

save_file = sprintf('data/results/%s/cvp_%0.2dk.mat', results_name, k);
fprintf('saving data to %s\n', save_file);
save(save_file,'btas','best_idx','type_list');

% [k l m] = size(bta_coexpression), k is the number of lambda, l is the number of alpha,
% m is the number of the genes. if setting beta =
% reshape(bta_coexpression(2,1,:),[],1), it return the coefficients learned
% from the algorithm when lambda equal to 1e-4 and alpha equal to 0.01.

