clear;

r00_my_config;
folder = params.folder;
k = 5; % do not need to change, i think

datasets = {'bono', 'tcga', 'tothill'};
networks = {'common', 'common_funlinkage'};

sets = cell(1,length(datasets) * length(networks));
count = 1;
for dix = 1:length(datasets)
	for nix = 1:length(networks)
		sets{count} = strcat(networks{nix}, '_', datasets{dix});
        count = count + 1;
	end

end

basedir = 'data/test';
basedir_gen = 'data/generated_source';

mydata_export = struct();

for six = 1:length(sets)
    dat_filename = sprintf('%s/%s.mat', basedir_gen, sets{six});
    fprintf('\nloading: %s ...\n', dat_filename);
    load(dat_filename);
		
	for kix = 1:k
        	fprintf('CV set: %d\n', kix);
		idx_filename = sprintf('%s/%s_0%dk_0%dg.mat', basedir, sets{six}, k, kix);
		fprintf('  loading: %s ...\n', idx_filename);
		load(idx_filename);
        	mydata_export(kix).(sets{six}).xdata = mydata.Data(:,idx_test);
        	mydata_export(kix).(sets{six}).xdata_n = mydata.Data_N(:,idx_test);
		mydata_export(kix).(sets{six}).ydata = [mydata.Times(idx_test), mydata.d(idx_test)];
		fprintf('  exporting %d features and %d observations\n', ...
		  size(mydata_export(kix).(sets{six}).xdata, 1),...
		  size(mydata_export(kix).(sets{six}).xdata, 2));
	end
end

mydata = mydata_export;
save_folder = sprintf('data/results/%s/determine_btas/', folder);
mkdir(save_folder);
save(sprintf('%s/cv_test_set.mat', save_folder), 'mydata');

