%%
clc;
clear;
%
k_vec = [1];
cv_k  = 5;
%
%prefix = 'common';
prefix = 'common_funlinkage';
%
% results directory
results_dir = 'degree_and_inverse_degree';
results_dir = 'big_degree_and_inverse';
results_dir = 'degree_all';
% loads cross-validation data
load(sprintf('data/results/%s/cvp_%0.2dk.mat',results_dir,cv_k));
%
vs_list   = {'bono', 'tcga'};
type_list = {'bono', 'tcga'};
%
%vs_list   = {'common_tcga'};
%type_list = {'common_bono'};
%
cmp = struct;
cmp.suffix = 'dc';
cmp.beta   = sprintf('beta_%s',cmp.suffix);
%cmp.beta   = 'beta_dc';
%
for jj = 1:length(vs_list)
    vs = sprintf('%s_%s',prefix,vs_list{jj});
    load(sprintf('data/generated_source/%s.mat',vs));
    out.(vs)        = struct;
    out.(vs).Data   = mydata.Data_N;
    out.(vs).Times  = mydata.Times;
    out.(vs).d      = mydata.d;
    out.(vs).Beta   = struct;
    out.(vs).PI     = struct;
    out.(vs).PI_sig = struct;
    out.(vs).lambda = struct;
    out.(vs).alpha  = struct;
    clear mydata
end
clear jj vs;

% set top and bottom 40% as two separate groups
risk_top_val  = .5;

my_alpha_vec = [0.01,0.5];
%%
%
% iterate all alpha values to be tested
for yy = 1:length(k_vec)
    k = k_vec(yy);
    for aa = 1:length(my_alpha_vec)
        target_alpha = my_alpha_vec(aa); % target alpha to be tested
        %
        % iterate over all test cases (can be itself)
        for bb = 1:length(vs_list)
            %
            vs = sprintf('%s_%s',prefix,vs_list{bb});
            % iterate over all sources for betas
            for cc = 1:length(type_list)
                % name for source
                type = sprintf('%s_%s',prefix,type_list{cc});
                %
                % load mydata
                load(sprintf('data/generated_source/%s.mat',type));
                % always get beta for 'k' K-fold parameter regression
                %  k should be 1
                data_prefix = sprintf('%s_%.2dk',type,cv_k);
                %
                %
                % add results from matlab to myrun
                %
                % load data from NetCox and DegreeCox
                load(sprintf('data/results/%s/%s.mat',results_dir,data_prefix));
                %
                %
                % add results from R to myrun
                %
                % load data from L1 + L2 regularization (done in R)
                load(sprintf('data/results/r_results/r_results_%s.mat',data_prefix));
                for dd = 1:cv_k
                    myrun(dd).beta_gl   = reshape(r_results(dd,:,:,:),size(r_results,2),size(r_results,3),size(r_results,4));
                    myrun(dd).lambda_gl = lambda_vec;
                    myrun(dd).alpha_gl  = alpha_vec;
                end
                clear dd r_results alpha_vec lambda_vec; % clear variables from R
                %
                % print out number of runs that have been loaded
                fprintf('# of runs loaded: %d\n', length(myrun));
                % idx of R alphas to use
                alpha_r_idx = [1,2];
                %
                for dd = 1:cv_k
                    %
                    pos = 1;
                    alpha_idx                           = pos(1);
                    lambda_idx                          = best_idx.(type).(cmp.beta).row(pos(1));
                    result.(type).Beta(dd).(cmp.suffix) = reshape(myrun(dd).(cmp.beta)(lambda_idx,alpha_idx,:),[],1);
                    result.(type).lambda.(cmp.suffix)   = best_idx.(type).(cmp.beta).lambda(lambda_idx);
                    result.(type).alpha.(cmp.suffix)    = 0;
                    %
                    pos = find( best_idx.(type).beta_nc.alpha == target_alpha );
                    alpha_idx                    = best_idx.(type).beta_nc.col(pos(1));
                    lambda_idx                   = best_idx.(type).beta_nc.row(pos(1));
                    result.(type).Beta(dd).nco   = reshape(myrun(dd).beta_nc(lambda_idx,alpha_idx,:),[],1);
                    result.(type).idx(dd).nco    = pos(1);
                    result.(type).lambda.nco     = best_idx.(type).beta_nc.lambda(lambda_idx);
                    result.(type).alpha.nco      = best_idx.(type).beta_nc.alpha(alpha_idx);
                    %        
                    lambda_idx                   = best_idx.(type).beta_gl.row(1);
                    %
                    result.(type).Beta(dd).l00   = reshape(myrun(dd).beta_gl( lambda_idx, alpha_r_idx(01), :), [], 1);
                    result.(type).Beta(dd).l10   = reshape(myrun(dd).beta_gl( lambda_idx, alpha_r_idx(02), :), [], 1);
                    %
                    result.(type).lambda.l00     = best_idx.(type).beta_gl.lambda(lambda_idx);
                    result.(type).alpha.l00      = best_idx.(type).beta_gl.alpha(alpha_r_idx(1));
                    %
                    result.(type).lambda.l10     = best_idx.(type).beta_gl.lambda(lambda_idx);
                    result.(type).alpha.l10      = best_idx.(type).beta_gl.alpha(alpha_r_idx(2));
                end
                clear dd lambda_idx alpha_idx alpha_r_idx pos
                %
                %
                %
                % Create ensemble model
                %
                % go through all model names
                model_names  = fieldnames(result.(type).Beta);
                % dc, nc, l01, l00
                for dd = 1:size(model_names,1)
                    m_name                 = model_names{dd};
                    result.(type).(m_name) = struct; % init model results 
                    %
                    %
                    % Ensemble model
                    Beta_temp = zeros( size(result.(type).Beta(1).(m_name),1), cv_k);
                    penal_sig = zeros( cv_k, 1 );
                    for ee = 1:k
                        % get cross-validation test dataset
                        DataTest        = mydata.Data(:,myrun(ee).idx_test);
                        % find Prognostic Index of the test data
                        PI_temp         = DataTest' * result.(type).Beta(ee).(m_name);
                        % save coefficients to temporary matrix
                        Beta_temp(:,ee) = result.(type).Beta(ee).(m_name);
                        % get x1 and x2 for log-rank test
                        [x1_temp, x2_temp] = get_x1_x2( PI_temp, risk_top_val, mydata.Times, mydata.d );
                        % get p_value of log-rank test
                        p_temp = calc_logrank_dir(x1_temp, x2_temp, 0);
                        % penalize in case p_value is below 0.05 for test set
                        if p_temp < 0.05
                            penal_sig(ee) = 1; 
                        else
                            % change from 1 to downgrade if does not fit well
                            penal_sig(ee) = .6 * (1-p_temp); 
                        end
                    end
                    penal_sig    = penal_sig ./ sum(penal_sig);
                    % init beta struct
                    ensemble_bta = Beta_temp * penal_sig;
                    out.(vs).Beta(yy,aa).(m_name) = zeros( size(ensemble_bta) );
                    out.(vs).Beta(yy,aa).(m_name)(:) = ensemble_bta(:);
                    clear ensemble_bta penal_sig ee PI_temp DataTest Beta_temp x1_temp x2_temp p_temp m_name;
                end
                clear dd m_name
                %
                %
                % Calculate PI (prognostic index of VS data)
                %
                %
                for dd = 1:size(model_names,1)
                    %
                    m_name = model_names{dd};
                    %
                    PI_sig = zeros(1,k);
                    PI_v   = zeros(k, size(out.(vs).Data,2));
                    for ee = 1:k
                        %
                        DataTest = out.(vs).Data(:,:);
                        PI_temp = DataTest' * out.(vs).Beta(yy,aa).(m_name);
                        PI_sig(ee) = 1; 
                        PI_v(ee,:) = PI_temp;
                    end
                    clear ee;
                    % average the PI
                    PI_sig = PI_sig ./ sum(PI_sig);
                    out.(vs).PI.(m_name)     = PI_sig*PI_v;
                    out.(vs).PI_sig.(m_name) = PI_sig;
                    %
                    clear PI PI_sig PI_v PI_temp DataTest;
                    %
                    %
                    [x1,x2] = get_x1_x2( out.(vs).PI.(m_name), risk_top_val, out.(vs).Times, out.(vs).d );
                    %
                    % set x1, x2 and PI in results structure
                    out.(vs).x1.(m_name)      = x1;
                    out.(vs).x2.(m_name)      = x2;
                    out.(vs).x1_name.(m_name) = 'Low risk';
                    out.(vs).x2_name.(m_name) = 'High risk';

                    p = calc_logrank( out.(vs) ,m_name  ,'x1', m_name  ,'x2', 0);
                    my_x1 = out.(vs).x1.(m_name);
                    my_x2 = out.(vs).x2.(m_name);
                    save(sprintf('data/results/survival/survival_groups-%s-%s-%s-%dk-%.2falpha.mat',type,vs,m_name,k,target_alpha), 'my_x1', 'my_x2','p');   
                    clear x1 x2 PI PI_v PI_sig my_x1 my_x2 p;
                end
                clear dd m_name;
                %
                %
                if 0
                    myrank = cell(6,2);
                    %
                    %
                    type = 'common_tcga';
                    [co_cmp_sort, co_cmp_idx] = sort(abs(result.(type).Beta(1).(cmp.suffix)));
                    myrank{1,1}               = 'DegreeCox (Coexpression)';
                    myrank{1,2}               = G(co_cmp_idx);
                    [co_nco_sort, co_nco_idx] = sort(abs(result.(type).Beta(1).nco));
                    myrank{2,1}               = sprintf('   NetCox (Coexpression) alpha=%0.2f', ...
                        best_idx.(type).beta_nc.alpha( result.(type).idx(1).nco ));
                    myrank{2,2}               = G(co_nco_idx);
                    %
                    %
                    type = 'common_funlinkage_bono';
                    [fl_cmp_sort, fl_cmp_idx] = sort(abs(result.(type).Beta(1).(cmp.suffix)));
                    myrank{3,1}               = 'DegreeCox (Functional Linkage)';
                    myrank{3,2}               = GeneName(fl_cmp_idx);
                    [fl_nco_sort, fl_nco_idx] = sort(abs(result.(type).Beta(1).nco));
                    myrank{4,1}               = sprintf('   NetCox (Functional Linkage) alpha=%0.2f', ...
                        best_idx.(type).beta_nc.alpha( result.(type).idx(1).nco ));
                    myrank{4,2}               = GeneName(fl_nco_idx);
                    %
                    % does not matter the source, as does not use network
                    [l10_sort, l10_idx] = sort(abs(result.(type).Beta(1).l10));
                    myrank{6,1}         = 'L1';
                    myrank{6,2}         = G(l10_idx);
                    [l00_sort, l00_idx] = sort(abs(result.(type).Beta(1).l00));
                    myrank{5,1}         = 'L2';
                    myrank{5,2}         = G(l00_idx);

                    %[l10_sort, l10_idx] = sort(abs(result.(type).Beta(1).l10));
                    %myrank{6,1}         = 'L1';
                    %myrank{6,2}         = G(l10_idx);
                    %
                    top_size   = 300;
                    top_ranked = cell(top_size,size(myrank,1));
                    for i = 1:top_size
                        for j = 1:size(myrank,1)
                            vec = 1:size(myrank,1);
                            vec = vec(vec ~= j);
                            for kk = vec
                                top_ranked{i,j} = cat(1, top_ranked{i,j},myrank{kk,2}(1:i) );
                            end
                            top_ranked{i,j} = unique(top_ranked{i,j});
                        end
                    end
                    %
                    top_intersect = zeros( top_size, size(myrank,1) );
                    for i = 1:top_size
                        for j = 1:size(myrank,1)
                           top_intersect(i,j) = size( intersect( myrank{j,2}(1:i), top_ranked{i,j} ) ,1) ./ i;
                        end
                    end
                    %
                    xx = (1:top_size);
                    yy = top_intersect' .* 100;
                    ll = myrank(:,1);
                    dd = [3,4];
                    save(sprintf('data/results/top_rank_%dk_%.2falpha.mat',k,target_alpha),'xx','yy','ll','dd');
                    createfigure(xx, yy, ll , dd );
                    gcapercent('y')
                end
            end
            clear cc;
        end
        clear bb;
    end
    clear aa;
end
clear k
