rm(list = ls())
library(R.matlab)
library(futile.logger)

networks <- c('funlinkage', 'correlation')
datasets <- c('tcga', 'bono', 'tothill')
#
#datasets <- 'bono'
#networks <- 'funlinkage'
#
result.set <- 'tothill_many'
#
k <- 1
data.basedir <- file.path('data', 'results', result.set, 'determine_btas')

cvdata  <- readMat(paste0(data.basedir, '/cv_test_set.mat'))
g.list <- 1
#
for (g in g.list) {
  #
  for (network.name in networks) {
    for (dataset.name in datasets) {
      #
      flog.info(paste0(network.name, '_', dataset.name, ':'))
      #
      my.type.export <- paste0('common_', network.name, '_', dataset.name, '_0', k, 'k_res')
      if (network.name == 'funlinkage') {
        my.type      <- my.type.export
        my.type.name <- paste0('common.', network.name, '.', dataset.name)
      } else if (network.name == 'correlation'){
        # stupid mistake since beginning, as correlation network
        #  is left unnamed
        my.type      <- paste0('common_', dataset.name, '_0', k, 'k_res')
        my.type.name <- paste0('common.', dataset.name)
      }
      
      # output dir
      out.dir <- file.path(data.basedir)
      
      gene.mat   <- readMat(file.path(out.dir, paste0(network.name, '_genes_name','.mat')))
      gene.names <- as.vector(unlist(gene.mat$genename))
      #
      max.output <- 200
      
      res <- readMat(file.path(out.dir, paste0(my.type,'.mat')))
      
      if (k > 1) {
        xdata   <- data.frame(t(cvdata$mydata[my.type.name,,g][[1]]['xdata',,][[1]]))
        xdata_n <- data.frame(t(cvdata$mydata[my.type.name,,g][[1]]['xdata.n',,][[1]]))
        ydata   <- data.frame(cvdata$mydata[my.type.name,,g][[1]]['ydata',,][[1]])
      } else {
        xdata   <- data.frame(t(res$xdata))
        xdata_n <- data.frame(t(res$xdata.n))
        ydata   <- data.frame(res$ydata)
      }
      colnames(xdata)   <- gene.names
      colnames(xdata_n) <- gene.names
      
      colnames(ydata) <- c('time', 'status')
      
      gene.btas.dc  <- as.vector(res$res["beta.dc",,][[g]]["btas",1,1][[1]])
      gene.btas.nc  <- as.vector(res$res["beta.nc",,][[g]]["btas",1,1][[1]])
      gene.btas.ri  <- as.vector(res$res["ridge",,][[g]]["btas",1,1][[1]])
      gene.btas.la  <- as.vector(res$res["lasso",,][[g]]["btas",1,1][[1]])
      
      names(gene.btas.dc) <- gene.names
      names(gene.btas.nc) <- gene.names
      names(gene.btas.ri) <- gene.names
      names(gene.btas.la) <- gene.names
          
      flog.info('dc')
      flog.info(summary(gene.btas.dc))
      
      flog.info('')
      flog.info('nc')
      print(summary(gene.btas.nc))
  
      flog.info('')
      flog.info('lasso')
      print(summary(gene.btas.la))
      
      flog.info('')
      flog.info('ridge')
      print(summary(gene.btas.ri))
      
      #
      save(file = file.path(out.dir, paste0('out_', my.type.export, '_0', g, 'g.RData')), 
           gene.names, gene.btas.dc, gene.btas.nc, gene.btas.ri, gene.btas.la, 
           xdata, xdata_n, ydata )
    }
  }
}